Imports System.ServiceProcess
Imports System.Configuration
Imports System.IO

Public Class checkService
    Inherits System.ServiceProcess.ServiceBase

    Private t As New System.Timers.Timer(5000)
    Private strControlPath As String
    Private strEndCodeFile As String
    Private strLogFile As String

    Dim myFileStream As System.IO.FileStream

#Region " Component Designer generated code "

    Public Sub New()
        MyBase.New()

        ' This call is required by the Component Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call

    End Sub

    'UserService overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' The main entry point for the process
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' More than one NT Service may run within the same process. To add
        ' another service to this process, change the following line to
        ' create a second service object. For example,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase() {New checkService}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    ' NOTE: The following procedure is required by the Component Designer
    ' It can be modified using the Component Designer.  
    ' Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'checkService
        '
        Me.ServiceName = "checkService"

    End Sub

#End Region

    Protected Overrides Sub OnStart(ByVal args() As String)
        loadVariables()
        t.Enabled = True
    End Sub

    Protected Overrides Sub OnStop()
        t.Enabled = False
    End Sub

    Private Sub loadVariables()
        'handler del timer
        AddHandler t.Elapsed, AddressOf TimerFired
        'variabili file application
        strControlPath = Configuration.ConfigurationSettings.AppSettings("strControlPath").ToString()
        strEndCodeFile = Configuration.ConfigurationSettings.AppSettings("strEndCodeFile").ToString()
        strLogFile = Configuration.ConfigurationSettings.AppSettings("strLogFile").ToString()
    End Sub

    Public Sub TimerFired(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs)
        'scrivo nel file di log il controllo che esista il file o no
        writeTxtFile(blnCheckExists(strControlPath & strEndCodeFile).ToString())
    End Sub

    'controlla l'esistenza di un file
    Private Function blnCheckExists(ByVal strFilePath As String) As Boolean
        Dim test As New FileInfo(strFilePath)
        If test.Exists() Then
            'il file esiste
            blnCheckExists = True
        Else
            'non esiste
            blnCheckExists = False
        End If
    End Function

    'scrive un file di testo log
    Private Sub writeTxtFile(ByVal strMessage As String)
        'apro il file, se non esiste lo creo
        myFileStream = New System.IO.FileStream(strLogFile, FileMode.Append, FileAccess.Write, System.IO.FileShare.None)
        Dim myWriter As New System.IO.StreamWriter(myFileStream)
        myWriter.WriteLine(Date.Now.ToString() & " - " & strMessage)
        myWriter.Close()
        myFileStream.Close()
    End Sub

End Class
